<template>
  <div>
    <h2 id="page-heading" data-cy="TokenDispHeading">
      <span v-text="$t('gatewayApp.manillaTokenDisp.home.title')" id="token-disp-heading">Token Disps</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaTokenDisp.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'TokenDispCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-token-disp"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaTokenDisp.home.createLabel')"> Create a new Token Disp </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && tokenDisps && tokenDisps.length === 0">
      <span v-text="$t('gatewayApp.manillaTokenDisp.home.notFound')">No tokenDisps found</span>
    </div>
    <div class="table-responsive" v-if="tokenDisps && tokenDisps.length > 0">
      <table class="table table-striped" aria-describedby="tokenDisps">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tokenConexion')">
              <span v-text="$t('gatewayApp.manillaTokenDisp.tokenConexion')">Token Conexion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'tokenConexion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('activo')">
              <span v-text="$t('gatewayApp.manillaTokenDisp.activo')">Activo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'activo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaInicio')">
              <span v-text="$t('gatewayApp.manillaTokenDisp.fechaInicio')">Fecha Inicio</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaInicio'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaFin')">
              <span v-text="$t('gatewayApp.manillaTokenDisp.fechaFin')">Fecha Fin</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaFin'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaTokenDisp.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="tokenDisp in tokenDisps" :key="tokenDisp.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'TokenDispView', params: { tokenDispId: tokenDisp.id } }">{{ tokenDisp.id }}</router-link>
            </td>
            <td>{{ tokenDisp.tokenConexion }}</td>
            <td>{{ tokenDisp.activo }}</td>
            <td>{{ tokenDisp.fechaInicio ? $d(Date.parse(tokenDisp.fechaInicio), 'short') : '' }}</td>
            <td>{{ tokenDisp.fechaFin ? $d(Date.parse(tokenDisp.fechaFin), 'short') : '' }}</td>
            <td>
              {{ tokenDisp.user ? tokenDisp.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'TokenDispView', params: { tokenDispId: tokenDisp.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'TokenDispEdit', params: { tokenDispId: tokenDisp.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(tokenDisp)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.manillaTokenDisp.delete.question" data-cy="tokenDispDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-tokenDisp-heading" v-text="$t('gatewayApp.manillaTokenDisp.delete.question', { id: removeId })">
          Are you sure you want to delete this Token Disp?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-tokenDisp"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeTokenDisp()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./token-disp.component.ts"></script>
